
    <style>
        body{
            color:#555;
        }
        .Arrow{
            width: 0px;
            height: 0px;
            border-top: 5px solid transparent;
            border-bottom: 5px solid transparent;
            border-left: 10px solid #333;
            font-size: 0px;
            line-height: 0px;
        }
        .cancel{
            padding:4px;
            font-weight: bold;
            background-color: red;
            font-size:10px;
            border-radius: 50%;
            color:white;
        }
        #draw{
            border:2px solid #ddd;
            width:80%;
            height:75%;
            position: relative;
        }
        .Arrow_pos,.cancel_pos{
            position: absolute;
        }
        .lf{
            float:left;
        }
        .side_bar{
            height:650px;
            width:10%;
        }
        .top_bar{
            width:85%;
            padding:10px;
            background-color:#ddd;
        }
        .side_bar{
            padding:10px;
        }
        .side_bar a{
            display:block;
            margin-bottom:30px;
            padding:25px;
            background-color:#1E90FF;
            color:white;
        }
        .side{
            border:1px solid #ddd;
            border-left:none;
            width:8%;
            height: 300px;
            padding-top:10px;
        }
        .side input{
            margin-left:10%;
        }
        #FC_save{
            padding:2px;
            float:right;
        }
    </style>
    <!--link rel="stylesheet" href="js/joint.css"/>
    <link rel="stylesheet" href="css/easyui.css"/>
    <link rel="stylesheet" href="css/icon.css"/>
    <script src="js/jquery.min.js"></script>
    <script src="js/lodash.min.js"></script>
    <script src="js/backbone-min.js"></script>
    <script src="js/joint.js"></script>
    <script src="js/jquery.easyui.min.js"></script>-->
<div class="mainDisplay">
    <div class="side_bar lf">
    {%  for index,item in steps %}
        <a class="movebtn FChart_btn_{{index}}" id="movebtn_{{index}}" data-property="{{item['code']}}" data-property_1="{{item['name']}}" data-name="{{item['cname']}}">{{item['cname']}}</a>
    {% endfor %}
      <!--  <a class="movebtn FChart_btn_2" id="movebtn_2" data-property="3333" data-property_1="4444" data-name="项目二">项目二</a>
        <a class="movebtn FChart_btn_3" id="movebtn_3" data-property="5555" data-property_1="6666" data-name="项目三">项目三</a>
        <a class="movebtn FChart_btn_4" id="movebtn_4" data-property="7777" data-property_1="8888" data-name="项目四">项目四</a>-->
    </div>
    <div class="top_bar lf">
        生产流程图
        <button id="FC_save">保存</button>
        <button id="zoom-in">放大</button>
        <button id="zoom-out">缩小</button>
    </div>
    <div id="draw" class="lf">
    </div>
    <div class="side lf">
        编号：<input type="text" id="shuxin" style="width: 80%">
        英文：<input type="text" id="shuxin_2" style="width: 80%">
    </div>
    <div id="FC_dialog" class="easyui-dialog"
         data-options="title:'生产流程图'"
         style="width:60%;height:600px;padding:10px;">

</div>
</div>
<script>
    /*功能说明
        1、设置全局变量方便各个函数调用
        2、先进行初始化操作SetInitial()
            设置jointjs画板资源的基本信息，并且创建两个基本图标：开始和结束图标
        3、子工单事件函数orderOpt()
            <1>创建子工单，拖拽事件的绑定
                 首先利用easyUI的拖拽事件,在停止拖动时根据所获取的html信息和放置在画布的位置
                 在绘制上绘制图标，同时调用属性的修改函数，保证在拖拽后能进行自定义属性数据的修改
                    （1）画布图形绘制
                        绘制相应图标并且根据所传入的属性进行更改，生成图标id转htmlid和htmlid转图标id的关联数组
            <2>画布图形 双击 事件函数：使用easyUI的dialog，双击图标打开相应的弹窗
            <3>画布图形 单击 事件函数：
                    (1)获取所点击图标的id和坐标，使用关联数组建立图标与按钮的联系
                        设定按钮的html，根据情况将其添加至图标的相应位置。
                        增加相应的判断，开始和结束标签没有删除按钮
                        并且点击连线按钮，生成一段连线供用户使用
                    (2)点击获得需要属性值，并且显示出来
        4、全局事件功能
                <1>删除事件，点击删除事件删除该按钮所对应的图标
                <2>清除按钮事件，当绘制完图标后，可以点击标题框，清除删除和连线按钮
                <3>放大缩小事件，根据所布置的图标密度不同，可以自己利用放大缩小的功能修改，
                    或者修改超出边界的连线
        5、保存事件
                利用jointjs的api生成json，用于保存所有图标、连线信息。
                首先对生成的json对象进行判断，是否有未连接好的连线，如果有，终止保存过程且指出哪条连线出错
            然后在对图标进行判断（除开始和结束图标）是否有孤立，没有连线的，如果有，自动删除。
            最后利用ajax将处理好的json发送。
        5、节点反解析
        */
    //全局变量
    $(function(){
    var graph;//设置资源面板
    var paper;//设置画布
    var Arrow_arr=[];//箭头按钮id与相应图标id的关联数组
    var Cancel_arr=[];//删除按钮id与相应图标id的关联数组
    var num=0;//用于形成按钮变量名的计数按钮
    var i=0;//****未知计数器****
    var FCID_arr=[];//图标id转htmlid关联数组
    var Draw_arr=[];//htmlid转图标id关联数组
    var sideWidth=parseFloat($(".sidebarMenu").css("width"));//侧栏的宽度
    var sideHeight=parseFloat($(".clearfix").css("height"));//侧栏的宽度
    //初始化函数
    function SetInitial(){
        //画布基本信息 资源画板 画布
        graph=new joint.dia.Graph();
        paper=new joint.dia.Paper({
            el:$("#draw"),//画布所在元素id
            width:($("#draw").width()),//画布宽度
            gridSize:1,//图标移动时允许的单位像素
            model:graph
        });
        //创建开始和结束图标
        var start = new joint.shapes.basic.Circle({
            position: { x: 10, y: 10 },//图标位置
            size: { width: 80 ,height: 80 },//图标尺寸
            attrs: { circle: { fill: 'gold',stroke:"none" },//图标属性——类型样式
                text: { text: '开始', fill: '#555' },//图标属性——文字属性
                name: { name: "start"}//增加开始的自定义标记属性
            }
        });
        var end = new joint.shapes.basic.Circle({
            position: { x: 900, y: 500 },
            size: { width: 80, height: 80 },
            attrs: { circle: { fill: 'gold',stroke:"none"},
                text: { text: '结束', fill: '#555' } ,
                name: { name:"end" }//增加结束的自定义标记属性
            }
        });
        graph.addCell(start).addCell(end);//将新建图标添加至画布
    }
//创建子工单函数
    function createOrder() {
//        var left = $("#draw").offset().left;//获取画布所在元素宽度
//        var top = $("#draw").offset().top;//获取画布所在元素的高度
//        var newCell=new joint.shapes.basic.Rect({
//        });//*****可能多余
        var p;
        //从资源面板拖拽到流程图事件
        $('.movebtn').draggable({
            revert:true,//拖拽完后返回 保证拖拽完 被拖拽元素仍在原地
            clone:true,//允许复制 保证拖拽时，被拖拽的元素仍然留在原地
            proxy:function(source){
                p = $(source.outerHTML);//所拖拽元素的HTML
                p.html($(source).html()).appendTo('body');//将选中移动的节点填充到画布
                return p;
            },
            //拖拽停止时，触发的事件
            onStopDrag:function(e){
                var item_html=e.data.target;//所触发元素的HTML
                $("#shuxin").val(item_html.getAttribute("data-property"));//获取所触发节点的HTML属性
                $("#shuxin_2").val(item_html.getAttribute("data-property_1"));
                var x=e.offsetX;//获取事件中元素坐标
                var y= e.offsetY;
                addNewCell(x,y,item_html);//将所触发的事件的图标在画布上绘制相应图标
                modification(item_html);//属性修改函数
            }
        });
    }
    //画布图形绘制函数
    var addNewCell = function(x,y,html){
        //获取所需的html属性 名称和自定义属性
        var name=html.getAttribute("data-name");
        var property=html.getAttribute("data-property");
        var property_1=html.getAttribute("data-property_1");
        //根据拖拽事件同时在画板上绘出相应的图标
        var newCell=new joint.shapes.basic.Rect({
            position: {
                x:x-50,//根据拖拽坐标进行位置修正
                y:y-25
            },
            attrs: {//属性需要传入相应图标的属性中
                rect:{fill:"#1E90FF",stroke:"none",property:property,property_1:property_1},
                text:{
                    fill:"white","font-size":12,text:name
                }
            },
            size: {width: 100,height:50}
        });
        graph.addCell(newCell);//将图标添加至画布
        FCID_arr[newCell.id]=html.id;//图标id转htmlid关联数组生成
        Draw_arr[html.id]=newCell.id;//htmlid转图标id关联数组生成
    };
    //画布图形事件函数
    function orderOpt(){
        createOrder();
        //双击打开弹框（双击事件）
        $("svg").on("dblclick",".rotatable",function(){
           var MID = $(this).parent().attr("model-id");
           var stepCode = $("#" + FCID_arr[MID]).attr("data-property");
           /* $.ajax({
                url:'/test/show/',
                data:{"code":stepCode},
                type:'post',
                success:function (msg) {
                    try {
                        var msgObj = jQuery.parseJSON(msg);
                    } catch (error) {
                        document.write(msg);
                        return ;
                    }
                    if (msgObj.code !=0) {
                        $.messager.alert('提示:',msgObj.message,'info');
                        return;
                    }

                    //加载数据项
                    var data = msgObj.data;
                    var operation = msgObj.operation;
                    var operator = msgObj.operator;

                    //加载基本信息项
                    $("#wf_cname").html(data['cname']);
                    $("#wf_name").html(data['name']);
                    $("#wf_description").html(data['description']);

                    //加载操作人选项
                    var operationData = [{
                        'text':'请选择',
                        'value':''
                    }];

                    for(var key  in operation) {
                        var obj = {
                            'text':operation[key],
                            'value':key
                        }
                        operationData.push(obj);
                    }

                    $("#opType").combobox({
                        'textField':'text',
                        'valueField':'value',
                        'data':operationData
                    });

                    if (operator) {
                       $("#operator").val(operator);
                    }

                    //加载





                }

            });


            $("#FC_dialog").dialog('open');*/
            location.href = '/workflowSteps/show/&code='+stepCode;
        });
        //生成按钮（单击事件）
        $("svg").on("click", ".rotatable", function (){
            //获取所点击的图标坐标和id
            var x = $(this).offset().left;
            var y = $(this).offset().top;
            var id = $(this).parent().attr("id");
            //关联数组建立按钮和图标的联系
            Arrow_arr["dudu_" + num] = id;
            Cancel_arr["cancel_" + num] = id;
            //按钮的html设定
            $("#draw").append("<div class='Arrow_pos' id='dudu_" + num + "'><span class='Arrow'></span></div>");
            //增加判断删除按钮不能加载开始和结束图标上
            if($(this).parent().attr("class")=="element basic Rect joint-theme-default"){
                $("#draw").append("<div class='cancel_pos' id='cancel_" + num + "'><p class='cancel'>X</p></div>");
                //删除按钮的坐标修正
                $(".cancel_pos").css("left", x - sideWidth-30);
                $(".cancel_pos").css("top", y - sideHeight-15);
            }
            //连线按钮的坐标修正
            $(".Arrow_pos").css("left", x - sideWidth-30);
            $(".Arrow_pos").css("top", y - sideHeight+20);
            num++;
            //点击获得属性功能
            var MID = $(this).parent().attr("model-id");
            $("#shuxin").val($("#" + FCID_arr[MID]).attr("data-property"));
            $("#shuxin_2").val($("#" + FCID_arr[MID]).attr("data-property_1"));
            var NowFC_html=$("#" + FCID_arr[MID])[0];
            modification(NowFC_html);
        });
        //连线按钮生成按钮事件
        $("#draw").on("click", ".Arrow_pos", function () {
            //获得按钮所对应的图标的id
            var s_id = Arrow_arr[$(this).attr("id")];
            //获取鼠标拖拽div的位置
            var linky = $("#" + s_id).offset().top+50 ;
            var linkx = $("#" + s_id).offset().left-100;
            //发出连线图标的id
            var sourID = $("#" + s_id).attr("model-id");
            //连线生成
            var link = new joint.dia.Link({
                source: {id: sourID},
                target: {x: linkx, y: linky}
            });
            link.attr({
                '.connection': {stroke: '#aaa', 'stroke-width': '4'},//strock修改连线颜色,strock-width修改粗细
                '.marker-target': {fill: '#000', d: 'M 10 0 L 0 5 L 10 10 z'}//fill修改箭头颜色
            });

            graph.addCell(link);//将连线添加至所在元素
        })
    }
    //修改属性并同时保存在相应的div标记和图标属性中
    function modification(html){
        $("#shuxin").off();
        $("#shuxin").blur(function(){
            $(html).attr("data-property",$("#shuxin").val());
           $(graph.getCell(Draw_arr[html.id]).attr("rect/property",$("#shuxin").val()));
        });
        $("#shuxin_2").off();
        $("#shuxin_2").blur(function(){
            $(html).attr("data-property_1",$("#shuxin_2").val());
            $(graph.getCell(Draw_arr[html.id]).attr("rect/property_1",$("#shuxin_2").val()));
        })
    }
    //*******全局功能函数*********
    function FC_total(){
            //弹框默认关闭
            $("#FC_dialog").dialog({
                closed:true
            });
            //删除节点事件
            $("#draw").on("click",".cancel_pos",function(){
                $("#"+Cancel_arr[$(this).attr("id")]).remove();
                $(".Arrow_pos").remove();
                $(".cancel_pos").remove();
            });
            //画图完成点击其他部分清理辅助按钮
            $(".top_bar").click(function(){
                $(".Arrow_pos").remove();
                $(".cancel_pos").remove();
            });

            //放大缩小事件
            var graphScale = 1;
            var paperScale = function(sx, sy) {paper.scale(sx, sy);};
            var zoomIn = function() {graphScale += 0.1;paperScale(graphScale, graphScale);};
            var zoomOut = function() {graphScale -= 0.1;paperScale(graphScale, graphScale);};
            $("#zoom-in").click(function(){zoomIn();});
            $("#zoom-out").click(function(){zoomOut();});
            //保存事件函数
            FC_save();
        }

    //*****解析函数*******
    function analysis(){
        graph.clear();
        $.ajax({
            url: 'json01.json',
            type: 'POST',
            dataType: 'json',
            success: function (msg){
                //找到已经保存的信息回填到页面
                console.log(msg);
                graph.fromJSON(msg);
            }
        })
    }
    //******保存功能函数*********
    function FC_save(){
        //数据保存发送函数
        $("#FC_save").click(function(){
            //生成json对象
            var res =graph.toJSON();
            //检查所连连线是否有未连接
            var num=1;      //连线次序标记
            var link_id=[];//连线的源头和指向id
            for(var i=0;i<res.cells.length;i++){
                var start_id=res.cells[0].id;
                var end_id=res.cells[1].id;
                //连线源头是否连接判断
                if(res.cells[i].type=="link"){
                    if(res.cells[i].source.id==undefined) {
                        $.messager.alert("警告","第 "+num+" 条连线 源头 未连接");
                        return false;
                    }else{
                        link_id[res.cells[i].source.id]=1;//保存源id
                    }
                    //连线指向是否连接判断
                    if(res.cells[i].target.id==undefined){
                        $.messager.alert("警告","第 "+num+" 条连线 箭头 未连接");
                        return  false;
                    }else{
                        link_id[res.cells[i].target.id]=1;//保存指向id
                    }
                    //检测开始和结束图标的事件
                    if(res.cells[i].target.id==start_id){
                        $.messager.alert("警告","开始图标不能作为指向");
                        return false;
                    }
                    if(res.cells[i].source.id==end_id){
                        $.messager.alert("警告","结束图标不能作为源头");
                        return false;
                    }
                    num++
                }
                }
            for(var c=0;c<res.cells.length;c++){
                //删除未连线图标
                if(res.cells[c].type=="basic.Rect"){
                    //console.log(link_id[res.cells[c].id]);
                    //删除无用图标和json
                        if(link_id[res.cells[c].id]==undefined){
                            $("[model-id="+res.cells[c].id+"]").remove();
                            delete res.cells[c];
                        }
                }
            }
            //执行流程图的保存
            $.ajax({


            });


            console.log("开始保存");
            //生成字符串形式json
            console.log(JSON.stringify(res));
        });
    }
    /*执行部分*/
    //执行初始化函数
    SetInitial();
    //执行子工单事件函数
    orderOpt();
    //全局事件
    FC_total();
    //解析JSON
//    analysis();
})
</script>
